//!OpenSCAD

Thickness = 8;
Diameter = 12;
Spacing = 4;
Padding = 13;
Rows = 8;
Columns = 2;
Generate_DXF = true;

module makeoutline() {
  cube([(Spacing * 2 + (Padding * 2 + (Spacing * 2 + (Padding + Diameter) * Columns))), (Spacing * 2 + (Padding * 2 + (Spacing * 2 + (Padding + Diameter) * Rows))), (Thickness / 10)], center=false);
}

module makepart() {
  difference() {
    translate([Padding, Padding, 0]){
      difference() {
        hull(){
          cylinder(r1=Padding, r2=Padding, h=Thickness, center=false);
          translate([(Spacing * 2 + (Padding + Diameter) * Columns), 0, 0]){
            cylinder(r1=Padding, r2=Padding, h=Thickness, center=false);
          }
          translate([(Spacing * 2 + (Padding + Diameter) * Columns), (Spacing * 2 + (Padding + Diameter) * Rows), 0]){
            cylinder(r1=Padding, r2=Padding, h=Thickness, center=false);
          }
          translate([0, (Spacing * 2 + (Padding + Diameter) * Rows), 0]){
            cylinder(r1=Padding, r2=Padding, h=Thickness, center=false);
          }
        }

        translate([Spacing, Spacing, (Thickness / 3)]){
          for (i = [1 : abs(1) : Rows]) {
            for (j = [1 : abs(1) : Columns]) {
              translate([(j * Diameter + Padding * (j - 1)), (i * Diameter + Padding * (i - 1)), 0]){
                cylinder(r1=Diameter, r2=Diameter, h=Thickness, center=false);
              }
            }

          }

        }
      }
    }

    translate([((Padding * 2 + (Spacing * 2 + (Padding + Diameter) * Columns)) / 2), 0, (Thickness / 3)]){
      cylinder(r1=Diameter, r2=Diameter, h=Thickness, center=false);
    }
  }
}

if (Generate_DXF == false) {
  makepart();
} else {
    projection(){
  difference() {
    union(){
      makeoutline();
      translate([(Spacing + (Spacing * 2 + (Padding * 2 + (Spacing * 2 + (Padding + Diameter) * Columns)))), 0, 0]){
        makeoutline();
      }
    }

    translate([Spacing, Spacing, (-(Thickness / 10))]){
      makepart();
      translate([(Spacing + (Spacing * 2 + (Padding * 2 + (Spacing * 2 + (Padding + Diameter) * Columns)))), 0, (-(Thickness * 0.8))]){
        makepart();
      }
    }
    }
  }
}
